
#define _TRACE

#include "include/CACHE.hpp"
#include "include/CS_ARRAY.hpp"

int main() {

	//CACHE::createInstance( 8, 128, 2);
	CS_ARRAY< int > arr( 10, "test array" );
	
	std::cout << "Setting incremental CS_ARRAY..." << std::endl;
	for( int i = 0; i<10; i++ )
		arr[ i ] = i;

	std::cout << "@0: " << arr[0]<<", @7: " << arr[7] << ", @9: " << arr[9] << std::endl;	

	/*std::cout << "sizeof( int ): " << sizeof( int ) << std::endl;
	std::cout << "sizeof( double ): " << sizeof( double ) << std::endl;

	int *ints; ints = new int[ 10 ];
	double *doubles; doubles = new double[ 10 ];

	std::cout << "pointer to ints: " << ints << std::endl;
	std::cout << "pointer to ints after cast: " << ( ( unsigned long int ) ints ) << std::endl;
	std::cout << "pointer to ints after double cast: " << ( ( unsigned long int ) ( ( void* ) ints ) ) << std::endl;
	std::cout << "pointer to doubles: " << doubles << std::endl;
	std::cout << "pointer to doubles after double cast: " << ( ( unsigned long int ) ( ( void* ) doubles ) ) << std::endl;

	std::cout << "Location of ints[4] after double cast: " << ( ( unsigned long int ) ( ( void* ) (&(ints[4])) ) ) << std::endl;
	std::cout << "Location of doubles[4] after ^: " << ( ( unsigned long int ) ( ( void* ) (&(doubles[4])) ) ) << std::endl;
	*/
	/*unsigned long int char_size;
	char *test = new char[2];
	char_size = (unsigned long int) &test[1];
	char_size-= (unsigned long int) &test[0];
	delete [] test;
	std::cout << "Char_size = " << char_size << std::endl;*/
	/*
	unsigned long int pred_int = ( unsigned long int ) ints;
	pred_int += 4 * sizeof( int );
	std::cout << "Naive prediction of ints[4]: " << pred_int << std::endl;
	pred_int = ( unsigned long int ) ( (void*) ints );
	pred_int += 4 * sizeof( int );
	std::cout << "My    prediction of ints[4]: " << pred_int << std::endl;

	unsigned long int pred_double = ( unsigned long int ) doubles;
	pred_double += 4 * sizeof( double );
	std::cout << "Naive prediction of doubles[4]: " << pred_double << std::endl;
	pred_double = ( unsigned long int ) ( (void*) doubles );
	pred_double += 4 * sizeof( double );
	std::cout << "My    prediction of doubles[4]: " << pred_double << std::endl;
	*/

	std::cout << "Setting decremental CS_ARRAY..." << std::endl;
	for( int i = 0; i<10; i++ )
		arr[ i ] = 9-i;

	std::cout << "@0: " << arr[0]<<", @7: " << arr[7] << ", @9: " << arr[9] << std::endl;	

	std::cout << "Cache misses: " << CACHE::getInstance()->getStatus()._misses << std::endl;
	std::cout << "Cache hits  : " << CACHE::getInstance()->getStatus()._hits << std::endl;

}

