#include "CACHE_SET_COLLECTION.hpp"

CACHE_SET_COLLECTION::CACHE_SET_COLLECTION() { std::cerr << "Should not call CACHE_SET_COLLECTION() default constructor!!!" << std::endl; }

CACHE_SET_COLLECTION::CACHE_SET_COLLECTION( unsigned int _k ) {
	k = _k;
	stack = new LRU_STACK( k );
}

bool CACHE_SET_COLLECTION::bringIntoCache( unsigned long int pointer ) {
	if ( stack->exists( pointer ) ) {
		stack->remove( pointer );
		stack->push( pointer );
#ifdef _TRACE
		std::cout << "*Cache hit" << std::endl;
#endif
		return true;
	} else {
		stack->push( pointer );
#ifdef _TRACE
		std::cout << "!Cache miss" << std::endl;
#endif
		return false;
	}
}

void CACHE_SET_COLLECTION::clear() { stack->clear(); }

CACHE_SET_COLLECTION::~CACHE_SET_COLLECTION() { delete stack; }

